---
title: Query aggregated long tasks
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > RUM Insights
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Query aggregated long tasks{% #query-aggregated-long-tasks %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                      |
| ----------------- | --------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/rum/query/insight/aggregated_long_tasks      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/rum/query/insight/aggregated_long_tasks      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/rum/query/insight/aggregated_long_tasks  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks |

### Overview

Get aggregated long task data for a RUM view, grouped by invoker type and sampled across multiple view instances. This endpoint requires the `rum_apps_read` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                            | Type   | Description                                                                                                                                                                  |
| ------------ | -------------------------------- | ------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]           | object | Data envelope for an aggregated long tasks request.                                                                                                                          |
| data         | attributes [*required*]     | object | Attributes for an aggregated long tasks query.                                                                                                                               |
| attributes   | application_id [*required*] | string | The RUM application ID to analyze.                                                                                                                                           |
| attributes   | criteria                         | object | Performance criteria to filter view instances by a metric threshold.                                                                                                         |
| criteria     | max                              | double | Maximum threshold in seconds (inclusive).                                                                                                                                    |
| criteria     | metric [*required*]         | enum   | Performance metric used to filter view instances by threshold. Allowed enum values: `loading_time,largest_contentful_paint,first_contentful_paint,interaction_to_next_paint` |
| criteria     | min                              | double | Minimum threshold in seconds (inclusive).                                                                                                                                    |
| attributes   | filter                           | string | RUM query string to filter events (for example, @session.type:user @geo.country:US).                                                                                         |
| attributes   | from [*required*]           | int64  | Start of the time range as a Unix timestamp in seconds.                                                                                                                      |
| attributes   | sample_size [*required*]    | int32  | Number of view instances to sample, between 1 and 500.                                                                                                                       |
| attributes   | to [*required*]             | int64  | End of the time range as a Unix timestamp in seconds.                                                                                                                        |
| attributes   | view_name [*required*]      | string | The RUM view name to analyze (for example, /account/login).                                                                                                                  |
| data         | type [*required*]           | enum   | The JSON:API type for aggregated long tasks requests. Allowed enum values: `aggregated_long_tasks`                                                                           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
      "criteria": {
        "max": 5,
        "metric": "largest_contentful_paint",
        "min": 2.5
      },
      "filter": "@session.type:user",
      "from": 1762437564,
      "sample_size": 20,
      "to": 1762523964,
      "view_name": "/account/login(/:type)"
    },
    "type": "aggregated_long_tasks"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Successful response
{% tab title="Model" %}
Response body for the aggregated long tasks endpoint.

| Parent field                  | Field                                        | Type     | Description                                                                                                                                                                  |
| ----------------------------- | -------------------------------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                               | data [*required*]                       | object   | Data envelope for an aggregated long tasks response.                                                                                                                         |
| data                          | attributes [*required*]                 | object   | Attributes of an aggregated long tasks response.                                                                                                                             |
| attributes                    | application_id [*required*]             | string   | The RUM application ID that was analyzed.                                                                                                                                    |
| attributes                    | criteria                                     | object   | Performance criteria to filter view instances by a metric threshold.                                                                                                         |
| criteria                      | max                                          | double   | Maximum threshold in seconds (inclusive).                                                                                                                                    |
| criteria                      | metric [*required*]                     | enum     | Performance metric used to filter view instances by threshold. Allowed enum values: `loading_time,largest_contentful_paint,first_contentful_paint,interaction_to_next_paint` |
| criteria                      | min                                          | double   | Minimum threshold in seconds (inclusive).                                                                                                                                    |
| attributes                    | from [*required*]                       | int64    | Start of the analyzed time range as a Unix timestamp in seconds.                                                                                                             |
| attributes                    | long_tasks_by_invoker_type [*required*] | [object] | Long task statistics grouped by invoker type, sorted by impact score descending.                                                                                             |
| long_tasks_by_invoker_type    | criteria_view_occurrences                    | int32    | Number of sampled views where this invoker type had long tasks contributing to the criteria metric.                                                                          |
| long_tasks_by_invoker_type    | impact_score                                 | double   | Rank-product impact score combining view frequency and blocking time severity.                                                                                               |
| long_tasks_by_invoker_type    | invoker_type [*required*]               | string   | Category of the long task invoker (for example, resolve-promise, user-callback).                                                                                             |
| long_tasks_by_invoker_type    | stats_per_view [*required*]             | object   | Statistical distributions of long task metrics computed per view across sampled views.                                                                                       |
| stats_per_view                | fcp_blocking_time_ms                         | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| fcp_blocking_time_ms          | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| fcp_blocking_time_ms          | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| fcp_blocking_time_ms          | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | fcp_count                                    | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| fcp_count                     | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| fcp_count                     | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| fcp_count                     | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | inp_overlap_blocking_time_ms                 | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| inp_overlap_blocking_time_ms  | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| inp_overlap_blocking_time_ms  | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| inp_overlap_blocking_time_ms  | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | inp_overlap_count                            | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| inp_overlap_count             | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| inp_overlap_count             | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| inp_overlap_count             | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | lcp_blocking_time_ms                         | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| lcp_blocking_time_ms          | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| lcp_blocking_time_ms          | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| lcp_blocking_time_ms          | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | lcp_count                                    | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| lcp_count                     | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| lcp_count                     | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| lcp_count                     | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | loading_time_blocking_time_ms                | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| loading_time_blocking_time_ms | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| loading_time_blocking_time_ms | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| loading_time_blocking_time_ms | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | loading_time_count                           | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| loading_time_count            | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| loading_time_count            | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| loading_time_count            | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | total_blocking_time_ms                       | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| total_blocking_time_ms        | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| total_blocking_time_ms        | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| total_blocking_time_ms        | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | total_count                                  | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| total_count                   | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| total_count                   | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| total_count                   | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| long_tasks_by_invoker_type    | top_invokers [*required*]               | [object] | Top invokers within this invoker type, sorted by impact score descending.                                                                                                    |
| top_invokers                  | criteria_view_occurrences                    | int32    | Number of sampled views where this invoker had long tasks contributing to the criteria metric.                                                                               |
| top_invokers                  | file [*required*]                       | string   | Cleaned source file path for the invoker script.                                                                                                                             |
| top_invokers                  | impact_score                                 | double   | Rank-product impact score combining view frequency and blocking time severity.                                                                                               |
| top_invokers                  | invoker [*required*]                    | string   | Name of the invoker function or script.                                                                                                                                      |
| top_invokers                  | stats_per_view [*required*]             | object   | Statistical distributions of long task metrics computed per view across sampled views.                                                                                       |
| stats_per_view                | fcp_blocking_time_ms                         | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| fcp_blocking_time_ms          | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| fcp_blocking_time_ms          | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| fcp_blocking_time_ms          | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | fcp_count                                    | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| fcp_count                     | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| fcp_count                     | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| fcp_count                     | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | inp_overlap_blocking_time_ms                 | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| inp_overlap_blocking_time_ms  | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| inp_overlap_blocking_time_ms  | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| inp_overlap_blocking_time_ms  | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | inp_overlap_count                            | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| inp_overlap_count             | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| inp_overlap_count             | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| inp_overlap_count             | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | lcp_blocking_time_ms                         | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| lcp_blocking_time_ms          | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| lcp_blocking_time_ms          | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| lcp_blocking_time_ms          | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | lcp_count                                    | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| lcp_count                     | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| lcp_count                     | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| lcp_count                     | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | loading_time_blocking_time_ms                | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| loading_time_blocking_time_ms | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| loading_time_blocking_time_ms | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| loading_time_blocking_time_ms | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | loading_time_count                           | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| loading_time_count            | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| loading_time_count            | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| loading_time_count            | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | total_blocking_time_ms                       | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| total_blocking_time_ms        | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| total_blocking_time_ms        | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| total_blocking_time_ms        | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| stats_per_view                | total_count                                  | object   | Statistical distribution (average, min, max) of a long task metric across sampled views.                                                                                     |
| total_count                   | average [*required*]                    | double   | Average value across sampled views.                                                                                                                                          |
| total_count                   | max [*required*]                        | double   | Maximum value across sampled views.                                                                                                                                          |
| total_count                   | min [*required*]                        | double   | Minimum value across sampled views.                                                                                                                                          |
| top_invokers                  | view_occurrences [*required*]           | int32    | Number of sampled views where this invoker had any long tasks.                                                                                                               |
| long_tasks_by_invoker_type    | view_occurrences [*required*]           | int32    | Number of sampled views where this invoker type had any long tasks.                                                                                                          |
| attributes                    | sampled_view_ids [*required*]           | [string] | List of RUM view IDs sampled for this aggregation, capped at 50.                                                                                                             |
| attributes                    | to [*required*]                         | int64    | End of the analyzed time range as a Unix timestamp in seconds.                                                                                                               |
| attributes                    | view_count [*required*]                 | int32    | Number of view instances included in the analysis.                                                                                                                           |
| attributes                    | view_name [*required*]                  | string   | The RUM view name that was analyzed.                                                                                                                                         |
| data                          | id [*required*]                         | string   | Hash-based unique identifier for this aggregation.                                                                                                                           |
| data                          | type [*required*]                       | enum     | The JSON:API type for aggregated long tasks requests. Allowed enum values: `aggregated_long_tasks`                                                                           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
      "criteria": {
        "max": 5,
        "metric": "largest_contentful_paint",
        "min": 2.5
      },
      "from": 1762437564,
      "long_tasks_by_invoker_type": [
        {
          "criteria_view_occurrences": 40,
          "impact_score": 0.4,
          "invoker_type": "resolve-promise",
          "stats_per_view": {
            "fcp_blocking_time_ms": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "fcp_count": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "inp_overlap_blocking_time_ms": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "inp_overlap_count": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "lcp_blocking_time_ms": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "lcp_count": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "loading_time_blocking_time_ms": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "loading_time_count": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "total_blocking_time_ms": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            },
            "total_count": {
              "average": 3504.1,
              "max": 3517.8,
              "min": 3500.1
            }
          },
          "top_invokers": [
            {
              "criteria_view_occurrences": 40,
              "file": "src/pages/Gallery.tsx",
              "impact_score": 0.67,
              "invoker": "Response.json.then",
              "stats_per_view": {
                "fcp_blocking_time_ms": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "fcp_count": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "inp_overlap_blocking_time_ms": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "inp_overlap_count": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "lcp_blocking_time_ms": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "lcp_count": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "loading_time_blocking_time_ms": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "loading_time_count": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "total_blocking_time_ms": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                },
                "total_count": {
                  "average": 3504.1,
                  "max": 3517.8,
                  "min": 3500.1
                }
              },
              "view_occurrences": 68
            }
          ],
          "view_occurrences": 68
        }
      ],
      "sampled_view_ids": [
        "6fbf69b6-9455-436a-b894-a6bf64126d40"
      ],
      "to": 1762523964,
      "view_count": 50,
      "view_name": "/account/login(/:type)"
    },
    "id": "2f0b3455",
    "type": "aggregated_long_tasks"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/rum/query/insight/aggregated_long_tasks" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "application_id": "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
      "from": 1762437564,
      "sample_size": 20,
      "to": 1762523964,
      "view_name": "/account/login(/:type)"
    },
    "type": "aggregated_long_tasks"
  }
}
EOF 
                
##### 

```python
"""
Query aggregated long tasks returns "Successful response" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.rum_insights_api import RUMInsightsApi
from datadog_api_client.v2.model.aggregated_long_tasks_request import AggregatedLongTasksRequest
from datadog_api_client.v2.model.aggregated_long_tasks_request_attributes import AggregatedLongTasksRequestAttributes
from datadog_api_client.v2.model.aggregated_long_tasks_request_data import AggregatedLongTasksRequestData
from datadog_api_client.v2.model.aggregated_long_tasks_request_type import AggregatedLongTasksRequestType
from datadog_api_client.v2.model.aggregated_waterfall_performance_criteria import AggregatedWaterfallPerformanceCriteria
from datadog_api_client.v2.model.aggregated_waterfall_performance_criteria_metric import (
    AggregatedWaterfallPerformanceCriteriaMetric,
)

body = AggregatedLongTasksRequest(
    data=AggregatedLongTasksRequestData(
        attributes=AggregatedLongTasksRequestAttributes(
            application_id="ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
            criteria=AggregatedWaterfallPerformanceCriteria(
                max=5.0,
                metric=AggregatedWaterfallPerformanceCriteriaMetric.LARGEST_CONTENTFUL_PAINT,
                min=2.5,
            ),
            filter="@session.type:user",
            _from=1762437564,
            sample_size=20,
            to=1762523964,
            view_name="/account/login(/:type)",
        ),
        type=AggregatedLongTasksRequestType.AGGREGATED_LONG_TASKS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["query_aggregated_long_tasks"] = True
with ApiClient(configuration) as api_client:
    api_instance = RUMInsightsApi(api_client)
    response = api_instance.query_aggregated_long_tasks(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Query aggregated long tasks returns "Successful response" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.query_aggregated_long_tasks".to_sym] = true
end
api_instance = DatadogAPIClient::V2::RUMInsightsAPI.new

body = DatadogAPIClient::V2::AggregatedLongTasksRequest.new({
  data: DatadogAPIClient::V2::AggregatedLongTasksRequestData.new({
    attributes: DatadogAPIClient::V2::AggregatedLongTasksRequestAttributes.new({
      application_id: "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
      criteria: DatadogAPIClient::V2::AggregatedWaterfallPerformanceCriteria.new({
        max: 5.0,
        metric: DatadogAPIClient::V2::AggregatedWaterfallPerformanceCriteriaMetric::LARGEST_CONTENTFUL_PAINT,
        min: 2.5,
      }),
      filter: "@session.type:user",
      from: 1762437564,
      sample_size: 20,
      to: 1762523964,
      view_name: "/account/login(/:type)",
    }),
    type: DatadogAPIClient::V2::AggregatedLongTasksRequestType::AGGREGATED_LONG_TASKS,
  }),
})
p api_instance.query_aggregated_long_tasks(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Query aggregated long tasks returns "Successful response" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AggregatedLongTasksRequest{
		Data: datadogV2.AggregatedLongTasksRequestData{
			Attributes: datadogV2.AggregatedLongTasksRequestAttributes{
				ApplicationId: "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
				Criteria: &datadogV2.AggregatedWaterfallPerformanceCriteria{
					Max:    datadog.PtrFloat64(5.0),
					Metric: datadogV2.AGGREGATEDWATERFALLPERFORMANCECRITERIAMETRIC_LARGEST_CONTENTFUL_PAINT,
					Min:    datadog.PtrFloat64(2.5),
				},
				Filter:     datadog.PtrString("@session.type:user"),
				From:       1762437564,
				SampleSize: 20,
				To:         1762523964,
				ViewName:   "/account/login(/:type)",
			},
			Type: datadogV2.AGGREGATEDLONGTASKSREQUESTTYPE_AGGREGATED_LONG_TASKS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.QueryAggregatedLongTasks", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewRUMInsightsApi(apiClient)
	resp, r, err := api.QueryAggregatedLongTasks(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `RUMInsightsApi.QueryAggregatedLongTasks`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `RUMInsightsApi.QueryAggregatedLongTasks`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Query aggregated long tasks returns "Successful response" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.RumInsightsApi;
import com.datadog.api.client.v2.model.AggregatedLongTasksRequest;
import com.datadog.api.client.v2.model.AggregatedLongTasksRequestAttributes;
import com.datadog.api.client.v2.model.AggregatedLongTasksRequestData;
import com.datadog.api.client.v2.model.AggregatedLongTasksRequestType;
import com.datadog.api.client.v2.model.AggregatedLongTasksResponse;
import com.datadog.api.client.v2.model.AggregatedWaterfallPerformanceCriteria;
import com.datadog.api.client.v2.model.AggregatedWaterfallPerformanceCriteriaMetric;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.queryAggregatedLongTasks", true);
    RumInsightsApi apiInstance = new RumInsightsApi(defaultClient);

    AggregatedLongTasksRequest body =
        new AggregatedLongTasksRequest()
            .data(
                new AggregatedLongTasksRequestData()
                    .attributes(
                        new AggregatedLongTasksRequestAttributes()
                            .applicationId("ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b")
                            .criteria(
                                new AggregatedWaterfallPerformanceCriteria()
                                    .max(5.0)
                                    .metric(
                                        AggregatedWaterfallPerformanceCriteriaMetric
                                            .LARGEST_CONTENTFUL_PAINT)
                                    .min(2.5))
                            .filter("@session.type:user")
                            .from(1762437564L)
                            .sampleSize(20)
                            .to(1762523964L)
                            .viewName("/account/login(/:type)"))
                    .type(AggregatedLongTasksRequestType.AGGREGATED_LONG_TASKS));

    try {
      AggregatedLongTasksResponse result = apiInstance.queryAggregatedLongTasks(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling RumInsightsApi#queryAggregatedLongTasks");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Query aggregated long tasks returns "Successful response" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_rum_insights::RUMInsightsAPI;
use datadog_api_client::datadogV2::model::AggregatedLongTasksRequest;
use datadog_api_client::datadogV2::model::AggregatedLongTasksRequestAttributes;
use datadog_api_client::datadogV2::model::AggregatedLongTasksRequestData;
use datadog_api_client::datadogV2::model::AggregatedLongTasksRequestType;
use datadog_api_client::datadogV2::model::AggregatedWaterfallPerformanceCriteria;
use datadog_api_client::datadogV2::model::AggregatedWaterfallPerformanceCriteriaMetric;

#[tokio::main]
async fn main() {
    let body = AggregatedLongTasksRequest::new(AggregatedLongTasksRequestData::new(
        AggregatedLongTasksRequestAttributes::new(
            "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b".to_string(),
            1762437564,
            20,
            1762523964,
            "/account/login(/:type)".to_string(),
        )
        .criteria(
            AggregatedWaterfallPerformanceCriteria::new(
                AggregatedWaterfallPerformanceCriteriaMetric::LARGEST_CONTENTFUL_PAINT,
            )
            .max(5.0 as f64)
            .min(2.5 as f64),
        )
        .filter("@session.type:user".to_string()),
        AggregatedLongTasksRequestType::AGGREGATED_LONG_TASKS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.QueryAggregatedLongTasks", true);
    let api = RUMInsightsAPI::with_config(configuration);
    let resp = api.query_aggregated_long_tasks(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Query aggregated long tasks returns "Successful response" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.queryAggregatedLongTasks"] = true;
const apiInstance = new v2.RUMInsightsApi(configuration);

const params: v2.RUMInsightsApiQueryAggregatedLongTasksRequest = {
  body: {
    data: {
      attributes: {
        applicationId: "ccbc53b1-74f2-496b-bdd7-9a8fa7b7376b",
        criteria: {
          max: 5.0,
          metric: "largest_contentful_paint",
          min: 2.5,
        },
        filter: "@session.type:user",
        from: 1762437564,
        sampleSize: 20,
        to: 1762523964,
        viewName: "/account/login(/:type)",
      },
      type: "aggregated_long_tasks",
    },
  },
};

apiInstance
  .queryAggregatedLongTasks(params)
  .then((data: v2.AggregatedLongTasksResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
